--- lambdabot-4.2.2.1-orig/State/poll	2009-01-18 16:01:16.000000000 +1100
+++ lambdabot-4.2.2.1/State/poll	2011-01-04 11:15:57.515382705 +1100
@@ -0,0 +1,12 @@
+"blah"
+(True,[("no",0),("yes",0)])
+food
+(True,[("quesadilla",1),("meatball-sub",0)])
+logoVotingMethod
+(True,[("Schulze",1)])
+naming
+(False,[("Lovelace",1),("Babbage",0)])
+remove@src
+(False,[("no",1),("yes",1)])
+threeway
+(False,[("method3",3),("method2",0),("method1",1)])
Files lambdabot-4.2.2.1-orig/State/quote and lambdabot-4.2.2.1/State/quote differ
Files lambdabot-4.2.2.1-orig/State/seen and lambdabot-4.2.2.1/State/seen differ
--- lambdabot-4.2.2.1-orig/State/source	2009-01-18 16:01:15.000000000 +1100
+++ lambdabot-4.2.2.1/State/source	2011-01-04 11:15:57.564383256 +1100
@@ -1,3 +1,7 @@
+asTypeIn
+a `asTypeIn` f = a where _ = f a
+infixl 0 `asTypeIn`
+
 Mu
 newtype Mu f = In { out :: f (Mu f) }
 
@@ -192,6 +196,7 @@
 
 (.)
 (f . g) x = f (g x)
+NB: In lambdabot,  (.) = fmap
 
 flip
 flip f x y = f y x
@@ -280,6 +285,11 @@
 break
 break p =  span (not . p)
 
+span
+span _ xs@[]                     =  (xs, xs)
+span p xs@(x:xs') | p x          =  let (ys,zs) = span p xs' in (x:ys,zs)
+                  | otherwise    =  ([],xs)
+
 reverse
 reverse = foldl (flip (:)) []
 
@@ -744,29 +754,9 @@
 exitFailure
 exitFailure = exitWith (ExitFailure 1)
 
-IO
-newtype IO a = IO (State# RealWorld -> (# State# RealWorld, a #))
-
 failIO
 failIO s = ioError (userError s)
 
-bindIO
-bindIO (IO m) k = IO ( \ s ->
-  case m s of (# new_s, a #) -> unIO (k a) new_s)
-
-thenIO
-thenIO (IO m) k = IO ( \ s ->
-  case m s of (# new_s, a #) -> unIO k new_s)
-
-returnIO :: a -> IO a
-returnIO x = IO (\ s -> (# s, x #))
-
-unsafePerformIO
-unsafePerformIO (IO m) = lazy (case m realWorld# of (# _, r #) -> r)
-
-unsafeInterleaveIO
-unsafeInterleaveIO (IO m) = IO ( \ s -> let r = case m s of (# _, res #) -> res in (# s, r #))
-
 FilePath
 type FilePath = String
 
@@ -800,10 +790,6 @@
 IOMode
 data IOMode = ReadMode | WriteMode | AppendMode | ReadWriteMode
 
-forkIO
-forkIO action = IO $ \ s -> case (fork# action_plus s) of (# s1, id #) -> (# s1, ThreadId id #)
-    where action_plus = catchException action childHandler
-
 killThread
 killThread tid = throwTo tid (AsyncException ThreadKilled)
 
@@ -837,9 +823,6 @@
 catch
 catch m k = catchException m handler where handler (IOException err) = k err
 
-evaluate
-evaluate a = IO $ \s -> case a `seq` () of () -> (# s, a #)
-
 Float
 data Float = F# Float#
 
@@ -1194,7 +1177,7 @@
 xs >>= f     = concatMap f xs
 
 [] (>>)
-xs >> ys      = concatMap (const xs) ys
+xs >> ys      = concatMap (const ys) xs
 
 [] return
 return x    = [x]
--- lambdabot-4.2.2.1-orig/State/system	2009-01-18 16:01:16.000000000 +1100
+++ lambdabot-4.2.2.1/State/system	2011-01-04 11:15:57.564383256 +1100
@@ -1 +1 @@
-((1223665727,565941000000),TimeDiff {tdYear = 0, tdMonth = 0, tdDay = 0, tdHour = 0, tdMin = 0, tdSec = 3368669, tdPicosec = 0})
\ No newline at end of file
+((1290244648,781347000000),TimeDiff {tdYear = 0, tdMonth = 0, tdDay = 0, tdHour = 0, tdMin = 0, tdSec = 3368669, tdPicosec = 0})
\ No newline at end of file
